/**
* @file        include.h
* @brief       This file contains all the functions prototypes for the include firmware library. 
* @author      ChipSea MCU Group
* @version     1.0.0
* @date        2022.04.14
* @copyright   CHIPSEA TECHNOLOGIES (SHENZHEN) CORP.
* @note        
****************************************************************************************************
* @par Modify record:
* <tr><th>Date          <th>Version    <th>Author     <th>Description
* <tr><td>2022.04.14    <td>1.0.0      <td>ChipSea    <td>
* -# 
* </table>
*
****************************************************************************************************
*/


#ifndef __CS_INCLUDE_H__
#define __CS_INCLUDE_H__


#ifdef __cplusplus
 extern "C" {
#endif


/***************************************************************************************************
 * @includes    standard includes
***************************************************************************************************/
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

/***************************************************************************************************
 * @includes    OS
***************************************************************************************************/
//#include "FreeRTOS.h"
//#include "task.h"
//#include "queue.h"
//#include "croutine.h"

/***************************************************************************************************
 * @includes    BSP
***************************************************************************************************/
#include "cs32f10x.h"
#include "cs32f10x_misc.h"
#include "cs32f10x_gpio.h"
#include "bsp.h"
#include "usart.h"

#include "bsp_can.h"
#include "cs32f10x_can.h"
#include "cs32f10x_usart.h"
#include "cs32f10x_rcu.h"
#include "cs32f10x_tim.h"

/***************************************************************************************************
 * @includes    Can Festival
***************************************************************************************************/
#include "canfestival.h"

/** @addtogroup CS_StdPeriph_Driver_FreeRTOS
  * @{
  */

/** @addtogroup include
  * @{
  */

/***************************************************************************************************
 * @definitions
***************************************************************************************************/
#define OS_ENABLE       0








#ifdef __cplusplus
}
#endif

#endif /* include.h */


/**
  * @}
  */

/**
  * @}
  */
