#include "include.h"
#include "app.h"
#include "bsp.h"
#include "usart.h"
#include "bsp_can.h"
#include "Slave_f103.h"
#include "node_config.h" //ڵ  дSDOĴӻֵֵ
#include "slave_callback.h"
#include "canfestival.h"


static void app_task(void *pvParameters);
static void canopen_app_task(void *pvParameters);
static void can_rcv_task(void *pvParameters);


xQueueHandle xCANRcvQueue = NULL;         //CANն


/**@brief       app_task
 *
 * @param[in]   
 *
 * @param[in]   
 *
 * @return      None.
 */
void app_task_create(void)
{
  BaseType_t xReturn;

  xReturn = xTaskCreate(app_task, "app_task", APP_STACK_SIZE, NULL, APP_TASK_PRIORITY, NULL);
  if(pdPASS != xReturn)
  {
    printf("app_task create failed");
    return;                                      
  }
}

/**@brief       նкcanfestival񣬷ֱͨbsp_can.ccanSend()ֱӷ
 *
 * @param[in]   
 *
 * @param[in]   
 *
 * @return      None.
 */
void canopen_driver_init(void)
{
  BaseType_t xReturn;

  if(xCANRcvQueue == NULL)
  {
    xCANRcvQueue = xQueueCreate(CANRX_QUEUE_LEN, sizeof(can_rx_msg_t));
    if(xCANRcvQueue == NULL)
    {
      printf("CANRcvQueue create failed");
      return;                                    
    }
  }

  xReturn = xTaskCreate(can_rcv_task, "can_rcv_task", CANRX_STACK_SIZE, NULL, CANRX_TASK_PRIORITY, NULL);
  if(pdPASS != xReturn)
  {
    printf("CANRcv_Task create failed");
    return;                                      
  }
}


static void can_rcv_task(void *pvParameters)
{
  static can_rx_msg_t rx_msg;
  static Message canopen_msg;

  for(;;)
  {
    if(xQueueReceive(xCANRcvQueue, &rx_msg, 100) == pdTRUE)
    {
      
       printf("յCANopen...\r\n"); 
    
       /* Assembly canopen data packet */
       canopen_msg.cob_id = rx_msg.std_id;
       canopen_msg.rtr    = rx_msg.remote_txreq;
       canopen_msg.len    = rx_msg.data_length;
       memcpy(canopen_msg.data, rx_msg.data, rx_msg.data_length);

       __TIM_INTR_DISABLE(TIM4, TIM_INTR_UPDATE);  
       canDispatch(&Slave_Data, &canopen_msg); 
       __TIM_INTR_ENABLE(TIM4, TIM_INTR_UPDATE);
    }
  }
}

void canopen_app_init(void)
{
    BaseType_t xReturn;
    
    /* CAN init PA11 RX / PA12 TX  500Kbps*/
    can_mode_config(CAN_TIME_CHANGE_UNIT_1,CAN_TS1_UNIT_9,CAN_TS2_UNIT_8,4,CAN_MODE_NORMAL);
    
    //Ҫtimerscfg.hMS_TO_TIMEVAL  US_TO_TIMEVAL   ӻΪ6553.5ms
    //1msжϣ10000hz  1s -> 10000 -> 1ms,10000/1000 = 10 ->  MS_TO_TIMEVAL(ms) ((ms) * 10)
    initTimer(); 
    
    canopen_driver_init();
    
    xReturn = xTaskCreate(canopen_app_task, "canopen_app_task", CANOPEN_STACK_SIZE, NULL, CANOPEN_TASK_PRIORITY, NULL);
    
    if(pdPASS != xReturn)
    {
        return;                                     
    }
}

static void canopen_app_task(void *pvParameters)
{    
    printf("CanOpen Slave Node Test...\r\n\n");
    
    unsigned char nodeID = SLAVE_NODE_ID; 
    
    setNodeId(&Slave_Data, nodeID);
    
    //InitialisationPre-operationalתӽڵԶ
    setState(&Slave_Data, Initialisation); 
    
    //ҪNMT ӽڵ㣬ӻɷSDO,PDO
//    setState(&Slave_Data, Operational); 

    while(1)
    {
        {
            Temperture[0] +=1; //ֵֵ   ͨPDO 
            
            if(getState(&Slave_Data) == 0x5)
            {
                Message temperture_value;
                temperture_value.cob_id = 0x281;
                temperture_value.rtr = 0;
                temperture_value.len = 4;
                memcpy(temperture_value.data, Temperture, temperture_value.len);
                canSend((&Slave_Data)->canHandle,&temperture_value);
            }
           else
           {
                UNS32 size = sizeof(UNS32);
                UNS16 index = 0x2000;
                UNS32 value = Temperture[0];
                UNS8 subindex=1;
		        writeLocalDict( &Slave_Data, /*CO_Data* d*/
		    								index,       /*UNS16 index*/
		    								subindex,         /*UNS8 subind*/ 
		    								&value,  /*void * pSourceData,*/ 
		    								&size,        /* UNS8 * pExpectedSize*/
		    								RW);          /* UNS8 checkAccess */
           }    
    
            
        }
        sdo_test[0] = 0xAA; //SDO Mapped at index 0x2002, subindex 0x01 - 0x01 -> 4f 02 20 01 00 00 00 00  
        
        printf("TempertureֵΪ%x...\r\n",Temperture[0]); 
        
        vTaskDelay(3000); //л 
    }
}


/**@brief       񣺵ײ㡢canopenЭջʼʼ
 *
 * @param[in]   
 *
 * @param[in]   
 *
 * @return      None.
 */
static void app_task(void *pvParameters)
{
     // PB10(TX) and PB11(RX);  LED1 15  LED2 14 ; PC13
    bsp_init(); 
    
    canopen_app_init();                                   

    while(1) //ûӦòapp
    {
        led1_toggle(); 
        led2_toggle();
        
        vTaskDelay(1000);                              
    }
}






