/**
* @file        main.c
* @brief       This file provides all the basic main firmware functions.
* @author      ChipSea MCU Group
* @version     0.0.1
* @date        2022.04.15
* @copyright   CHIPSEA TECHNOLOGIES (SHENZHEN) CORP.
* @note        
****************************************************************************************************
* @par Modify record:
* <tr><th>Date          <th>Version    <th>Author     <th>Description
* <tr><td>2022.04.15    <td>0.0.1     <td>ChipSea    <td>
* -# 
* </table>
*
****************************************************************************************************
*/


/***************************************************************************************************
 * @includes
***************************************************************************************************/
#include "include.h"
#include "canfestival.h"

#include "Slave_f103.h"
#include "node_config.h" //ڵ  дSDOĴӻֵֵ
#include "slave_callback.h"
#include "app.h"

/***************************************************************************************************
 * @definitions
***************************************************************************************************/
static int slave_callback(void);


/** @addtogroup main
  * @{
  */

/** @defgroup main
  * @brief    main driver modules
  * @{
  */

///@cond

/***************************************************************************************************
 * @variables
***************************************************************************************************/


/***************************************************************************************************
 * @function
***************************************************************************************************/
int main(void)  
{
    nvic_priority_group_config(NVIC_PriorityGroup_4); //RTOS 
    
    slave_callback();
    
    app_task_create();

    vTaskStartScheduler();

    return 0;
}    


static int slave_callback(void) //ȫֻӡϢ  
{
		
    Slave_Data.heartbeatError = Slave_Data_heartbeatError; //ֵԭʼֵΪ _heartbeatErrorǸպ,
                                                            //󣬴ӡϢ 
    Slave_Data.initialisation = Slave_Data_initialisation; //user app init callback
    Slave_Data.preOperational = Slave_Data_preOperational;
    Slave_Data.operational = Slave_Data_operational;
    Slave_Data.stopped   = Slave_Data_stopped;
    Slave_Data.post_sync = Slave_Data_post_sync;     //յͬappҪ
    Slave_Data.post_TPDO = Slave_Data_post_TPDO;     //TPD0appҪ ,ͬtpdO
    Slave_Data.storeODSubIndex = Slave_Data_storeODSubIndex;
    Slave_Data.post_emcy = Slave_Data_post_emcy;     //ӻյϢappҪ
	
	return 0;
}

#ifdef  USE_FULL_ASSERT

/**@brief       Report the assert error.
 *
 * @param[in]   file: pointer to the source file name.
 *
 * @param[in]   line: error line source number.
 *
 * @return      None.
 */
void assert_failed(uint8_t* file, uint32_t line)
{
    while(1);
}

#endif

///@endcond

/**
  * @}
  */

/**
  * @}
  */
